package com.ruoyi.bst.area.utils;

import java.math.BigDecimal;

import com.ruoyi.bst.area.domain.Area;
import com.ruoyi.common.utils.map.GeoUtils;
import org.locationtech.jts.geom.Geometry;

public class AreaUtil {


    public static boolean isInArea(Area area, BigDecimal longitude, BigDecimal latitude) {
        double tolerance = 0; // 误差距离
        if (area.getError() != null) {
            tolerance = area.getError().doubleValue();
        }
        Geometry geometry = GeoUtils.fromWkt(area.getBoundary());
        if (geometry == null) {
            return false;
        }
        return GeoUtils.isInPolygonWithTolerance(longitude, latitude, geometry, tolerance);
    }

}
